<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- plugin-lifecycle.qdoc -->
  <title>Plugin Life Cycle | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >Plugin Life Cycle</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<div class="sidebar"><div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Plugin Life Cycle</h1>
<span class="subtitle"></span>
<!-- $$$plugin-lifecycle.html-description -->
<div class="descr"> <a name="details"></a>
<p>To be able to write Qt Creator plugins, you must understand the steps that the plugin manager takes when you start or shut down Qt Creator. This section describes the process and the state that plugins go through in detail.</p>
<p>You can get more information about what happens when you start Qt Creator by running it with the environment variable <code>QT_LOGGING_RULES</code> set to <code>qtc.extensionsystem*=true</code> which enables logging of plugin-related debug output.</p>
<p>When you start Qt Creator, the plugin manager does the following:</p>
<ol class="1" type="1"><li>Looks in its search paths for all dynamic libraries, and reads their meta data. All libraries without meta data and all libraries without the <code>org.qt-project.Qt.QtCreatorPlugin</code> IID are ignored. This is the first point where loading a plugin can fail in the worst case of malformed meta data.</li>
<li>Creates an instance of the ExtensionSystem::PluginSpec class for each plugin. This class is a container for all the information from the plugin specification, and additionally tracks the state of the plugin. You can get the ExtensionSystem::PluginSpec instances via the plugin manager's plugins() function, or, after a plugin is loaded, through the plugin's pluginSpec() function.</li>
<li>Sets the plugins to <code>Read</code> state.</li>
<li>Verifies that the dependencies of each plugin exist and are compatible. For more information about plugin dependencies, see Plugin Specifications.</li>
<li>Sets the plugins to <code>Resolved</code> state.</li>
<li>Sorts all plugins into a list that we call the <i>load queue</i>, where the dependencies of a plugin are positioned after the plugin (but not necessarily <i>directly</i> after the plugin). It will make sure that we load and initialize the plugins in proper order.</li>
<li>Loads the plugins' libraries, and creates their IPlugin instances in the order of the load queue. At this point the plugin constructors are called. Plugins that other plugins depend on are created first.</li>
<li>Sets the plugins to <code>Loaded</code> state.</li>
<li>Calls the initialize() functions of all plugins in the order of the load queue. In the <code>initialize</code> function, a plugin should make sure that all exported interfaces are set up and available to other plugins. A plugin can assume that plugins they depend on have set up their exported interfaces. For example, the <code>Core</code> plugin sets up the Core::ActionManager, Core::EditorManager and all other publicly available interfaces, so other plugins can request and use them.<p>The initialize() function of a plugin is a good place for</p>
<ul>
<li>registering objects in the plugin manager's object pool (see <a href="pluginmanager.html">The Plugin Manager, the Object Pool, and Registered Objects</a>)</li>
<li>loading settings</li>
<li>adding new menus, and new actions to menus</li>
<li>connecting to other plugin's signals.</li>
</ul>
</li>
<li>Sets the plugins to <code>Initialized</code> state.</li>
<li>Calls the extensionsInitialized() functions of all plugins in <i>reverse</i> order of the load queue. After the <code>extensionsInitialized</code> function, a plugin should be fully initialized, set up and running. A plugin can assume that plugins that depend on it are fully set up, and can finish the initialization of parts that can be extended by other plugins. For example, the <code>Core</code> plugin assumes that all plugins have registered their actions, and finishes initialization of the action manager.</li>
<li>Sets the plugins to <code>Running</code> state.</li>
</ol>
<p>At the end of startup, the <code>Core</code> plugin's Core::ICore sends two signals. Before the Qt Creator UI is shown it sends coreAboutToOpen(), and afterwards coreOpened().</p>
<p>After startup, when the event loop of Qt Creator is running, the plugin manager calls the delayedInitialize() functions of all plugins in <i>reverse</i> order of the load queue. The calls are done on the main thread, but separated by a delay of a few milliseconds to ensure responsiveness of Qt Creator. In the <code>delayedInitialize</code> function, a plugin can perform non-critical initialization that could unnecessarily delay showing the Qt Creator UI if done during startup.</p>
<p>After all delayed initializations are done the PluginManager sends the initializationDone() signal.</p>
<p>Before shutdown, the <code>Core</code> plugin Core::ICore sends the coreAboutToClose() signal. After that, the plugin manager starts its shutdown sequence:</p>
<ol class="1" type="1"><li>Calls the aboutToShutdown() functions of all plugins in the order of the load queue. Plugins should perform measures for speeding up the actual shutdown here, like disconnecting signals that would otherwise needlessly be called. If a plugin needs to delay the real shutdown for a while, for example if it needs to wait for external processes to finish for a clean shutdown, the plugin can return ExtensionSystem::IPlugin::AsynchronousShutdown from this function. This will make the plugin manager wait with the next step, and keep the main event loop running, until all plugins requesting AsynchronousShutdown have sent the asynchronousShutdownFinished() signal.</li>
<li>Destroys all plugins by deleting their ExtensionSystem::IPlugin instances in <i>reverse</i> order of the load queue. At this point the plugin destructors are called. Plugins should clean up after themselves by freeing memory and other resources.</li>
</ol>
</div>
<!-- @@@plugin-lifecycle.html -->
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
